@ int fracmul(signed int x, signed int frac)
@ Multiply by a 0.32 fractional number.
@ Used for fast division by a constant.

.ARM
.ALIGN
.GLOBL  fracmul

fracmul:
  smull r1,r2,r0,r1
  mov r0, r2
  bx lr


@ int fracumul(unsigned int x, unsigned int frac)
@ Multiply by a 0.32 fractional number.
@ Used for fast division by a constant.

.ARM
.ALIGN
.GLOBL  fracumul

fracumul:
  umull r1,r2,r0,r1
  mov r0, r2
  bx lr


@ int dv(int num, int den)
@ Divide two signed integers.

.THUMB
.THUMB_FUNC
.ALIGN
.GLOBL  dv

dv:
  cmp r1, #0
  beq 0f
  swi 6
  bx lr
0:
  ldr r0, =0x7fffffff
  bx lr


@ void gbrle_unpack(const void *src, void *dst)
@ Unpack GB RLE format data.

.THUMB
.THUMB_FUNC
.ALIGN
.GLOBL  gbrle_unpack

gbrle_unpack:
  swi 0x14  @ RLUnCompWRAM
  bx lr


@ void gblz_unpack(const void *src, void *dst)
@ Unpack GB LZSS format data.

.THUMB
.THUMB_FUNC
.ALIGN
.GLOBL  gblz_unpack

gblz_unpack:
  swi 0x11  @ LZ77UnCompWRAM
  bx lr
